<template>
  <div class="reset-page">
    <img class="logo" src="../assets/logo_1.png" alt="">
    <p class="title">重置密码</p>
    <p class="description">请输入新密码以重置 Let's Code 帐号密码</p>
    <div class="form">
      <a-form-model ref="form" :model="formData" :rules="formRules">
        <a-form-model-item>
          <a-input v-model="formData.name" disabled size="large" placeholder="用户名">
            <a-icon slot="prefix" type="user" style="color:#517E55"/>
          </a-input>
        </a-form-model-item>
        <a-form-model-item prop="password">
          <a-input-password v-model="formData.password" allowClear visibilityToggle size="large" type="password" placeholder="新密码（8-16位字母和数字）">
            <a-icon slot="prefix" type="lock" style="color:#517E55"/>
          </a-input-password>
        </a-form-model-item>
        <a-form-model-item prop="confirmPassword">
          <a-input-password v-model="formData.confirmPassword" allowClear visibilityToggle size="large" type="password" placeholder="请再次输入新密码">
            <a-icon slot="prefix" type="lock" style="color:#517E55"/>
          </a-input-password>
        </a-form-model-item>
        <a-form-model-item>
          <a-button size="large" block :loading="loading" type="primary" @click="handleDone">重置密码</a-button>
        </a-form-model-item>
      </a-form-model>
    </div>
  </div>
</template>

<script>
export default {
  name: "reset_password",

  data() {
    let validatePassword = (rule, value, callback) => {
      let reg = /^(?=.*\d)(?=.*[a-zA-Z])[\da-zA-Z]{8,16}$/g
      if (!value) {
        return callback(new Error('密码为必填项'));
      } else if (!reg.test(value)) {
        return callback(new Error('密码必须为8-16位字母和数字的组合'));
      } else {
        if (this.formData.confirmPassword != '') {
          this.$refs.form.validateField('confirmPassword');
        }
        callback();
      }
    }

    let validateConfirmPassword = (rule, value, callback) => {
      if (!value) {
        return callback(new Error('密码为必填项'));
      } else if (value != this.formData.password) {
        return callback(new Error('两次密码不一致'));
      } else {
        callback()
      }
    }
    return {
      check_code: "",
      formData: {
        name: "",
        password: "",
        confirmPassword: ""
      },
      formRules: {
        password: [{validator: validatePassword, trigger: 'blur'}],
        confirmPassword: [{validator: validateConfirmPassword, trigger: 'blur'}],
      },
      loading: false
    }
  },

  created() {
    this.formData.name = this.$route.query.name
    this.check_code = this.$route.query.check_code
  },

  methods: {
    handleDone() {
      this.$refs.form.validate( async valid => {
        if (valid) {
          this.loading = true
          await this.$axios.post('register/reset_password', {
            name: this.formData.name,
            password: this.formData.password,
            check_code: this.check_code
          }).then(res => {
            if (res.code == 0) {
              this.$router.replace('/login')
              this.$notification.success({
                message: '您的密码已重置成功'
              })
            } else if (res.code == 501) {
              this.$notification.error({
                message: res.info
              })
            } else {
              this.$notification.error({
                message: '密码重置失败'
              })
            }
          }).catch(() => {
            this.$notification.error({
              message: '密码重置失败'
            })
          })
          this.loading = false
        }
      })
    }
  }
}
</script>

<style lang="less" scoped>
  .reset-page {
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    padding-top: 100px;
    .logo {
      width: 250px;
      margin-bottom: 30px;
    }
    .title {
      font-weight: bold;
      font-size: 32px;
      margin-bottom: 12px;
    }
    .description {
      width: 600px;
      text-align: center;
      color: #8C92A4;
      margin-bottom: 50px;
    }
    .form {
      width: 300px;
    }
  }
</style>